<?php if (!defined('PmWiki')) exit();

$ExtendAlpha = "A-Za-z\xc0-\xd6\xd8-\xf6\xf8-\xff";
$CitePattern = "[$ExtendAlpha][-.:0-9$ExtendAlpha]*";
$ReferenceTag = array('o' => '<:block><tbook:references class="sic">'.
  (($action=='publish') ? '<tbook:h level="'.
      (($_GET['ptype']=='book') ? '0' : '1').'">&bibname;</tbook:h>' : ''), 
  'c' => '<:block></tbook:references>',
  'n' => '<tbook:hspace dim="-" />');

$CitationGroupDepth = (($_GET['ptype']=='book') ? '' : 'sub').'section';

## bib lists
$BlockMarkups['bib'] = array("<tbook:bibliography>\n<tbook:item>",
  '</tbook:item><tbook:item>',"</tbook:item>\n</tbook:bibliography>",1);
Markup('^B:','block','/^B(:)\s?(\s*)/','<:bib,$1,$0>$2');
Markup('^M:','block','/^M:\s*(.*)$/',
  "<:block><tbook:p style='hangingauthor'>$1</tbook:p>");
Markup_e('^REF:','block','/^RE!:\s*(.*)$/',
  "'<:block,1>'.
   CitationGroup(\$GLOBALS['HeadingDepth'][\$pagename],\$GLOBALS['PageAnchors'][\$pagename]).
   '<tbook:h level=\"'.CitationHeading(\$GLOBALS['HeadingDepth'][\$pagename]).
   PSS('\">\$m[1]</tbook:h>')");
if ($action=='publish') {
    $CiteOpt['title'] = 'References for [[#{$PageAnchor} | !{$Title}]]';
    $FmtPV['$PageAnchor'] = '$GLOBALS["PageAnchors"]["$group.$name"]';
} else $PageAnchors[$pagename] = '';
function CitationHeading($depth) {
  $k = 1;
  foreach (array('section','subsection','subsubsection','paragraph','subparagraph') as $v)
    if ($depth==$v) return $k; else $k++;
  return $k;
}
function CitationGroup($depth, $anchor) {
  global $CitationGroupDepth;
  return (($depth==$CitationGroupDepth) ? 
      '<tbook:group id="bib.'.$anchor.'"></tbook:group>' : '');
}

Markup_e('cite','inline',
  "/(\*?[Cc])ite(-?[PpTtYy]?)\((?:\"([^\"]*)\"\s*)?($CitePattern)(?:\s*\"([^\"]*)\")?\)('s)?/",
  "(\$m[5]=='*') ? '' : (CiteKeyExists(\$m[4]) ? Keep('<tbook:cite refid=\"'.
  \$pagename.'.'.MakeValidCite(\$m[4]).'\" kind=\"sic\">'.
  ReferenceText(\$m[1],(\$m[2] ? \$m[2] : '*'),\$m[4],\$m[3],\$m[5],\$m[6]).
  '</tbook:cite>') : 
  ReferenceText(\$m[1],(\$m[2] ? \$m[2] : '*'),\$m[4],\$m[3],\$m[5],\$m[6]))");
$MarkupFrameBase['posteval']['bib'] =
  "\$out = preg_replace_callback('/(<references[^>]*>.*?<\/references>)(.*?)$/s',".
      "\"CitationFooterCallback\",\$out);";

function CiteKeyExists($ref) {
  global $CitationList;
  $ir = strtolower($ref);
  return $CitationList['reftext'][$ir] ? true : false;
}

function CitationLabel($label) {
  if (preg_match('/^\[(.*?)\]/',$label,$match))
    return ' style="'.$match[1].'"';
  else return '';
}
function CitationFooterCallback($m) {
  return $m[2].CitationFooter($m[1]);
}
function CitationFooter($references) {
  global $HTMLFooterFmt, $LongestCiteKey;
  if (@$LongestCiteKey) $references = str_replace("<bibliography>",
    "<bibliography style=\"$LongestCiteKey\">",$references);
  $r = '</references>'; $g = '</group>'; $gr = $g.$r;
  if (preg_match("|$g|", $references))
      $references = str_replace(array($g, $r), array('', $gr), $references);
  elseif (preg_match("|$gr$|", $HTMLFooterFmt['bib'])) {
      $HTMLFooterFmt['bib'] = str_replace($gr, $r, $HTMLFooterFmt['bib']);
      $references = str_replace($r, $gr, $references);
  }
  $HTMLFooterFmt['bib'] .= preg_replace_callback(
                               '/(<item)>([^<]*)<wrap([^>]*)><\/wrap>\s*/',
                               function ($m) {
                                 return $m[1].$m[3].CitationLabel($m[2]).'>';
                               },
                               $references);
  $HTMLFooterFmt['bib'] = preg_replace('/<\/references><references[^>]*>(<h.*?\/h>)?/',
    '', $HTMLFooterFmt['bib']);
}

?>
